***************************************************************************************
*                                                                                     *
*  Bu Program DIZI Adresiyle Verilen 16 Bitlik Sayi Dizisindeki Tek ve Cift Sayilari  *
*      Sirasiyla Ayirarak TEK ve CIFT Isimleriyle Verilen Adreslere Yazmaktadir.      *
*                                                                                     *
* ----------------------------------------------------------------------------------- *
*                                                                                     *
*  Bilgisayar Mimarisi (68000)      I. ODEV              Beycan Kahraman - 040020337  *
*                                                                                     *
***************************************************************************************

CIFT    equ     $1100        *   Cift Sayilarin Yazilacagi Bellek Gozunun Baslangic Adresi
TEK     equ     $1200        *   Tek Sayilarin Yazilacagi Bellek Gozunun Baslangic Adresi
SAYI    equ     100          *   Cift ve Tek Olarak Ayrilacak Toplam 

        org     $0FA0        *   Programin Baslangic Adresi

TEKCIFT lea     DIZI,A0      *   Asagida Tanimladigimiz Dizinin Etkin Adresini A0'da Tutuyoruz
        move.l  #CIFT,A1     *   Yukarda Tanimladigimiz Cift Sayilarin Yazilacagi Adresi A1'de Tutuyoruz
        move.l  #TEK,A2      *   Yukarda Tanimladigimiz Tek Sayilarin Yazilacagi Adresi A2'de Tutuyoruz
        move.w  #SAYI,D1     *   Uzerinde Teklik Ciftlik Denemesi Yapilacak Toplam Word Sayisini D1'de Tutuyoruz
        subq.w  #1,D1        *   DBcc Kullanacagimizdan Dongu Sayisini 1 Azaltiyoruz ( -1'e Kadar Islenecek )
DONGU   move.w  (A0),D0      * \            Siradaki Degeri D0'a Al
        and.w    #1,D0       *  |           Son Bitini 1 ile Ve'le, Boylece Tek ya da Cift Oldugunu Ogren
        beq     CIFT_W       *  |           Eger Sonuc Sifir (0) Ciktiysa CIFT_WORD Adimina Dallan
        move.w  (A0)+,(A2)+  *  > DONGU     Sonuc Tek  : TEK  Dizisine Sayiyi Ekle 
        bra TEKRAR           *  |
CIFT_W  move.w  (A0)+,(A1)+  *  |           Sonuc Cift : CIFT Dizisine Sayiyi Ekle 
TEKRAR  dbf    D1,DONGU      * /
        stop    #$2000       *   Program Sona Erdi :)

        org     $1000        *   Verilecek Dizinin Baslangic Adresi
DIZI    dc.w    5,8,4,8,8,7,4,0,8,6,2,0,0,2,0,5,2,2,4,5,0,6,1,8,6,1,2,5,5,2,4,4,9,8,9,7,6,1,1,4,3,1,1,6,3,4,4,9,4,7,4,3,9,3,6,3,0,1,0,5,0,6,0,7,4,4,4,6,3,9,5,7,5,4,9,0,0,8,1,2,3,5,3,0,0,2,6,9,4,3,3,9,6,0,6,9,2,6,4,0
        end     TEKCIFT      *   TekCift Burada Sona Eriyor

***************************************************************************************
*  NOT: Program DIZI icin Verdigimiz Degerlerin Buyuk Oldugu Durumda Yazi Editorunun  *
*       Sonuna Gelindiginden Dizideki Degerleri Sonuna Kadar Okuyamamakta;            *
*       Bu da Belli Bir Toplam Uzunluga Kadar Olan Dizide Calisma Ani Hatasi,         *
*       Daha Uzun Degerlerde Ise Derlenme Hatasi Vermektedir.                         *
***************************************************************************************